#version 140

#ifdef GL_ES
precision highp float;
#endif

out vec4 fragColor;

in vec2 uvOut;
in vec4 colOut;

uniform sampler2D tex;

void main(void)
{
	vec4 col = texture(tex, uvOut);
	// input is sRGB but not tagged as sRGB texture because it's shared with UI
	col.xyz = pow(col.xyz, vec3(2.2));
	col *= colOut;

	if (col.a < 0.5)
		discard;

	fragColor = col;
}
