#version 140

// simple textured with color
#ifdef GL_ES
precision highp float;
#endif

#include "../include/fragData.frag"
#include "../include/clip_plane.frag"

// texture uvs
in vec2 uvOut;
// color
in vec4 colOut;
// diffuse only color scale
in vec4 diffColOut;

in float fadeoutAmount;

// diffuse color
uniform sampler2D tex;

in vec3 worldNormOut;

//#define ALPHATEST_SUPERSAMPLING

void main(void)
{
	clip_pixel();

	vec4 diffuse = texture(tex, uvOut);

#ifdef ALPHATEST_SUPERSAMPLING
	vec2 dx = dFdx(uvOut)*0.5;
	vec2 dy = dFdy(uvOut)*0.5;

	diffuse += texture(tex, uvOut + dx + dy);
	diffuse += texture(tex, uvOut - dx + dy);
	diffuse += texture(tex, uvOut - dy);

	diffuse *= colOut*0.25;
#else
	diffuse *= colOut;
#endif


/*	// dither-based fadeout looks horrible, especially when grass is animated!
	// Intel HD4000 crashes if this is const... tnx pta
	mat4 dither = mat4(
	0.0/16.0, 8.0/16.0, 2.0/16.0, 10.0/16.0,
	12.0/16.0, 4.0/16.0, 14.0/16.0, 6.0/16.0,
	3.0/16.0, 11.0/16.0, 1.0/16.0, 9.0/16.0,
	15.0/16.0, 7.0/16.0, 13.0/16.0, 5.0/16.0);

	ivec2 iv = ivec2(mod(gl_FragCoord.xy, vec2(4.0)));
	float dith = dither[iv.y][iv.x];

	if (diffuse.w < 0.5 || dith < fadeoutAmount)
		discard;*/

	if (diffuse.w < 0.5)
		discard;

#ifndef NO_SPEC_BUFFER
	fragData3 = vec4(0.0);
#endif

#ifndef NO_NORM_BUFFER
#ifdef BOTHSIDED
	fragData2.xyz = gl_FrontFacing ? worldNormOut : vec3(1.0) - worldNormOut;
#else
	fragData2.xyz = worldNormOut;
#endif
	// bend up
	fragData2.xyz = mix(fragData2.xyz, vec3(0.5, 0.5, 1.0), 0.75);
#endif

	fragData1 = diffuse * diffColOut;
	fragColor = diffuse * colOut;

	//fragColor.rgb = vec3(fadeoutAmount);
}
