#version 140

// simple textured with color
#ifdef GL_ES
precision highp float;
#endif

#include "../include/fragData.frag"

#include "../include/clip_plane.frag"

// texture uvs
in vec2 uvOut;
// color
in vec4 colOut;
// diffuse only color scale
in vec4 diffColOut;

in float fadeoutAmount;

// diffuse color
uniform sampler2D tex;

in vec3 worldNormOut;

void main(void)
{
	clip_pixel();

	vec4 diffuse = texture(tex, uvOut) * colOut;

#ifndef NO_SPEC_BUFFER
	fragData3 = vec4(0.0);
#endif

#ifndef NO_NORM_BUFFER
#ifdef BOTHSIDED
	fragData2.xyz = gl_FrontFacing ? worldNormOut : vec3(1.0) - worldNormOut;
	// bend up
	fragData2.xyz = mix(fragData2.xyz, vec3(0.5, 0.5, 1.0), 0.75);
#else
	fragData2.xyz = worldNormOut;
#endif
#endif

	fragData1 = diffuse * diffColOut;
	fragColor = diffuse * colOut;
}
