#version 140

// simple textured with color
#ifdef GL_ES
precision highp float;
#endif

#include "include/fragData.frag"
#include "include/clip_plane.frag"

// texture uvs
in vec2 uvOut;
// color
in vec4 colOut;

// diffuse color
uniform sampler2D tex;
// reflection cubemap
uniform samplerCube tex2;

in vec3 worldNormOut;
in vec3 worldDirOut;

void main(void)
{
	clip_pixel();

	vec4 diffuse = texture(tex, uvOut);

	// no need to normalize I suppose?
	vec3 rd = reflect(worldDirOut, normalize(worldNormOut - vec3(0.5)));

	// note: should be -r.z, but actually this is how my cubemap "screenshot" works
	vec3 reflectDir = vec3(-rd.y, rd.z, rd.x);

	vec4 reflColor = textureLod(tex2, reflectDir, 0.0);
	//reflColor.xyz = vec3(reflColor.x + reflColor.y + reflColor.z) * (1.0/3.0);

	vec4 lit = diffuse;

	reflColor -= vec4(0.65);
	reflColor = max(reflColor, vec4(0.0));
	reflColor *= reflColor;
	reflColor *= 8.0;

	lit += reflColor;
	//lit *= 1.3;

	//diffuse.xyz = vec3(1.0);
#ifndef NO_SPEC_BUFFER
	fragData3 = vec4(0.0);
#endif

#ifndef NO_NORM_BUFFER
	fragData2.xyz = worldNormOut;
#endif

	fragData1 = diffuse;
	fragColor = lit * colOut;
}
