#version 140

// old-school lightmapping
#ifdef GL_ES
precision highp float;
#endif

#include "include/fragData.frag"
#include "include/clip_plane.frag"

// texture uvs
in vec2 uvOut;
// lightmap uvs
in vec2 uvOut2;

#ifndef NO_NORM_BUFFER
in vec3 worldNormOut;
#endif

// diffuse color
uniform sampler2D tex;
// base color lightmap
uniform sampler2D tex2;

//#define ALPHATEST_SUPERSAMPLING

void main(void)
{
	clip_pixel();

	vec4 b0 = unpack_lightmap(texture(tex2, uvOut2));

	vec4 diffuse;
	vec4 final;

	diffuse = texture(tex, uvOut);

#ifdef ALPHATEST_SUPERSAMPLING
	vec2 dx = dFdx(uvOut)*0.5;
	vec2 dy = dFdy(uvOut)*0.5;

	diffuse += texture(tex, uvOut + dx + dy);
	diffuse += texture(tex, uvOut - dx + dy);
	diffuse += texture(tex, uvOut - dy);

	diffuse *= 0.25;
#endif

	if (diffuse.w < 0.5)
		discard;

#ifndef NO_SPEC_BUFFER
	fragData3 = vec4(0.0);
#endif

#ifndef NO_NORM_BUFFER
#ifdef BOTHSIDED
	fragData2.xyz = gl_FrontFacing ? worldNormOut : vec3(1.0) - worldNormOut;
#else
	fragData2.xyz = worldNormOut;
#endif
#endif

	fragData1 = diffuse;

	// use diffuse alpha for potential transparency
	final.xyz = b0.xyz;

	// fake ambient
	//final.xyz = max(final.xyz, vec3(0.2));

	final.w = diffuse.w;

	// 2x overbright
	final.xyz *= diffuse.xyz * 2.0;

	fragColor = final;
}
