#version 140

// old-school lightmapping
#ifdef GL_ES
precision highp float;
#endif

#include "include/fragData.frag"
#include "include/clip_plane.frag"

//#define SIMPLE_BLEND

//#define USE_GAMMA

// texture uvs
in vec2 uvOut;
// lightmap uvs
in vec2 uvOut2;
// color (alpha_blend)
in vec4 colOut;

// diffuse color
uniform sampler2D tex;
// secondary diffuse color
uniform sampler2D tex2;
// base color lightmap
uniform sampler2D tex3;

float fakeheight(vec4 color)
{
	// compensate for linear
	color = sqrt(color);
	return (color.x + color.y + color.z)*(1.0/3.0);
}

#ifndef NO_NORM_BUFFER
in vec3 worldNormOut;
#endif

void main(void)
{
	clip_pixel();

/*		mat4 dither = mat4(
	0.0, 8.0, 2.0, 10.0,
	12.0, 4.0, 14.0, 6.0,
	3.0, 11.0, 1.0, 9.0,
	15.0, 7.0, 13.0, 5.0) / (16.0*128.0);*/

	vec4 b0 = unpack_lightmap(texture(tex3, uvOut2));

#ifdef USE_GAMMA
	// unpack lightmap
	b0.xyz = pow(b0.xyz, vec3(2.2));
#endif

	vec4 diffuse;
	vec4 final;

/*	ivec2 iv = ivec2(gl_FragCoord.x, gl_FragCoord.y);
	float uofs = dither[iv.y & 3][iv.x & 3]*2.0;
	float vofs = dither[iv.x & 3][iv.y & 3]*2.0;

	uvOut += vec2(uofs, vofs);*/

	vec4 diffuse1 = texture(tex, uvOut);
	vec4 diffuse2 = texture(tex2, uvOut);

#ifdef SIMPLE_BLEND
	diffuse = mix(diffuse1, diffuse2, colOut.a);
#else

	// we need better blending here, based on normals
	// reference: http://untitledgam.es/2017/01/height-blending-shader/

	// blending using heightmap (=bump), only if available; not set by default
	float height1 = fakeheight(diffuse1) * (1.0-colOut.a);
	float height2 = fakeheight(diffuse2) * (colOut.a);

	// this should be a parameter...
	float height_max = max(height1, height2) - 0.1;
	float weight1 = max(height1 - height_max, 0.0001);
	float weight2 = max(height2 - height_max, 0.0001);
	float weight_scale = 1.0 / (weight1+weight2);
	diffuse = (diffuse1*weight1 + diffuse2*weight2)*weight_scale;

	//diffuse = mix(diffuse1, diffuse2, colOut.a);
#endif

#ifdef USE_GAMMA
	diffuse.xyz = pow(diffuse.xyz, vec3(2.2));
#endif

#ifndef NO_SPEC_BUFFER
	fragData3 = vec4(0.0);
#endif

#ifndef NO_NORM_BUFFER
	fragData2.xyz = worldNormOut;
#endif

	fragData1 = diffuse;

	// use diffuse alpha for potential transparency
	final.xyz = b0.xyz;

	// fake ambient
	//final.xyz = max(final.xyz, vec3(0.2));

	final.w = diffuse.w;

	// 2x overbright
	final.xyz *= diffuse.xyz * 2.0;

#ifdef USE_GAMMA
	final.xyz = pow(final.xyz, vec3(1.0/2.2));
#endif

	fragColor = final;
}
