#version 140

#include "include/quat_vec.vert"
#include "include/clip_plane.vert"

in vec3 pos;
in vec2 uv;
in vec2 uv2;
in vec3 norm;
in vec4 tang;

uniform mat4 proj;
uniform vec4 model_trans;
uniform vec4 model_quat;

out vec2 uvOut;
out vec2 uvOut2;

out vec3 worldNormOut;

uniform vec3 world_camera_position;
out vec3 worldDirOut;

void main(void)
{
	vec3 vpos = pos;
	vpos = quat_vec(model_quat, vpos) * model_trans.w +
		model_trans.xyz;

	clip_vertex(vpos);

	gl_Position = proj * vec4(vpos, 1.0);

	uvOut = uv;
	uvOut2 = uv2;

	worldNormOut = quat_vec(model_quat, norm) * 0.5 + vec3(0.5);

	worldDirOut = vpos.xyz - world_camera_position;

	// now transform to tangent space
	vec3 normal = quat_vec(model_quat, norm);
	vec3 tangent = quat_vec(model_quat, tang.xyz);
	vec3 bitangent = quat_vec(model_quat, cross(norm, tang.xyz) * tang.w);

	mat3 tang_to_world;

	tang_to_world[0] = tangent;
	tang_to_world[1] = bitangent;
	tang_to_world[2] = normal;

	vec3 dir = worldDirOut;

	// actually dir in tangent space
	worldDirOut = dir * tang_to_world;
}
