#version 140

#include "include/quat_vec.vert"
#include "include/clip_plane.vert"

in vec3 pos;
in vec2 uv;
in vec2 uv2;

uniform vec4 model_trans;
uniform vec4 model_quat;
uniform mat4 proj;

out vec2 uvOut;
out vec2 uvOut2;

uniform float animTime0;

void main(void)
{
	vec3 ipos = pos;

	// simple stupid vertex waves
	float arg = 2.0*3.1415927*animTime0+ipos.z;
	float scale = 0.0025;

	ipos.x += cos(arg + pos.x)*scale;
	ipos.y += sin(arg + pos.z)*scale;
	ipos.z += cos(arg + pos.z)*scale*0.25;

	vec3 vpos = ipos;
	vpos = quat_vec(model_quat, vpos) * model_trans.w +
		model_trans.xyz;

	clip_vertex(vpos);

	gl_Position = proj * vec4(vpos, 1.0);

	uvOut = uv;
	uvOut2 = uv2;
}
