#include "../include/srgb.frag"

//#define USE_TONEMAP

#ifdef USE_TONEMAP

// world's dumbest tonemapping
float TONEMAP_A = 0.5;
float TONEMAP_B = 0.75;

vec3 Tonemap(vec3 color)
{
	//return color;
	vec3 threshold = vec3(TONEMAP_A);
	vec3 base = color - threshold;
	vec3 extra = max(base, vec3(0.0));
	extra *= TONEMAP_B;

	return color / (extra + vec3(1.0));
}

vec3 TonemapKeep(vec3 color)
{
	// this is supposed to be unlit - attempt to undo tonemapping using 2 forward passes
	color.xyz *= color.xyz / (Tonemap(color.xyz) + vec3(0.0001));
	color.xyz *= color.xyz / (Tonemap(color.xyz) + vec3(0.0001));
	return color;
}

#else

vec3 Tonemap(vec3 color)
{
	return color;
}

vec3 TonemapKeep(vec3 color)
{
	return color;
}

#endif
