#version 140

#ifdef GL_ES
precision highp float;
#endif

#include "include/fragColor.frag"
#include "include/clip_plane.frag"

// texture uvs
in vec2 uvOut;

in vec2 uvShift;
in vec2 uvShift2;
in vec2 uvShift3;

// diffuse color
uniform sampler2D tex;

void main(void)
{
	clip_pixel();

	vec4 final = texture(tex, uvOut + uvShift);
	final *= vec4(0.7, 0.85, 1.0, 1.0);

	vec4 temp = texture(tex, ((uvOut + uvShift2)*0.5 + vec2(0.3, 0.7)).xy);
	temp *= vec4(0.5, 0.7, 0.9, 1.0);

	final.xyz *= temp.xyz;

	temp = texture(tex, ((uvOut + uvShift3)*0.25 + vec2(0.6, 0.1)).xy);
	temp *= vec4(0.6, 0.9, 0.7, 1.0);

	final.xyz += temp.xyz;

	// make lighter
	final.xyz = sqrt(final.xyz);

	fragColor = final;
}
