#version 140

// simple textured with color
#ifdef GL_ES
precision highp float;
#endif

#include "include/fragColor.frag"
#include "include/clip_plane.frag"

// texture uvs
in vec2 uvOut;
in vec2 uvOut2;
// color
in vec4 colOut;

// diffuse color
uniform sampler2D tex;
uniform sampler2D tex2;
uniform sampler2D tex3;

uniform float smoke_alpha1;
uniform float smoke_alpha2;

void main(void)
{
	clip_pixel();

	vec4 diffuse = texture(tex, uvOut);

	vec2 uvOutPat1 = uvOut + uvOut2 + vec2(smoke_alpha1);
	vec2 uvOutPat2 = uvOut + uvOut2 + vec2(smoke_alpha2);

	vec4 pat1 = texture(tex2, uvOutPat1*0.125);
	vec4 pat2 = texture(tex3, uvOutPat2*0.25);

	vec4 final;

	final.a = (diffuse.a * pat1.a*1.0)*pat2.a*2.0;
	final.rgb = diffuse.rgb;

	fragColor = final * colOut;
}
