vec3 srgb_to_linear(vec3 color)
{
	return pow(color, vec3(2.2));
}

vec3 linear_to_srgb(vec3 color)
{
	return pow(color, vec3(1.0/2.2));
}

vec4 srgb_to_linear(vec4 color)
{
	color.rgb = srgb_to_linear(color.rgb);
	return color;
}

vec4 linear_to_srgb(vec4 color)
{
	color.rgb = linear_to_srgb(color.rgb);
	return color;
}

// my very simple approximation using square/sqrt
vec3 srgb_to_linear_approx(vec3 color)
{
	color *= color;
	color *= 0.973823;
	return color;
}

vec3 linear_to_srgb_approx(vec3 color)
{
	color *= 1.0/0.973823;
	color = sqrt(max(color, vec3(0.0)));
	return color;
}

vec4 srgb_to_linear_approx(vec4 color)
{
	color.rgb = srgb_to_linear_approx(color.rgb);
	return color;
}

vec4 linear_to_srgb_approx(vec4 color)
{
	color.rgb = linear_to_srgb_approx(color.rgb);
	return color;
}
